package de.thpeetz.kontor.tysc.views;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;

import de.thpeetz.kontor.tysc.data.CardSet;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class CardSetForm extends FormLayout {

    TextField name = new TextField("Name");

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<CardSet> binder = new BeanValidationBinder<>(CardSet.class);

    public CardSetForm() {
        addClassName("cardSet-form");
        binder.bindInstanceFields(this);

        add(name, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(e -> save.setEnabled(binder.isValid()));
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setCardSet(CardSet cardSet) {
        binder.setBean(cardSet);
    }

    public abstract static class CardSetFormEvent extends ComponentEvent<CardSetForm> {
        private CardSet cardSet;

        protected CardSetFormEvent(CardSetForm source, CardSet cardSet) {
            super(source, false);
            this.cardSet = cardSet;
        }

        public CardSet getCardSet() {
            return cardSet;
        }
    }

    public static class SaveEvent extends CardSetFormEvent {
        SaveEvent(CardSetForm source, CardSet cardSet) {
            super(source, cardSet);
        }
    }

    public static class DeleteEvent extends CardSetFormEvent {
        DeleteEvent(CardSetForm source, CardSet cardSet) {
            super(source, cardSet);
        }
    }

    public static class CloseEvent extends CardSetFormEvent {
        CloseEvent(CardSetForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
